import greenfoot.*;  // (World, Actor, GreenfootImage, and Greenfoot)

/**
 * An ant that collects food.
 * 
 * @author Michael Kolling
 * @version 0.1
 */
public class Ant extends Creature
{
    private boolean carryingFood;
    private int stepsUntilIForgetISmelledPheromone;
    private int steps;
    
    /**
     * Create an ant with a given home hill. The initial speed is zero (not moving).
     */
    public Ant(AntHill home)
    {
        setHomeHill(home);
        carryingFood = false;
        stepsUntilIForgetISmelledPheromone = 0;
        steps = 0;
    }

    /**
     * Do what an ant's gotta do.
     */
    public void act()
    {
        if(carryingFood == true) {
            walkTowardsHome();
            steps = steps + 1;
            if(steps == 18) {
                getWorld().addObject(new Pheromone(), getX(), getY());
                steps = 0;
            }
            checkForAntHill();            
        }
        else {
            if(stepsUntilIForgetISmelledPheromone > 0) {
                walkAwayFromHome();
                stepsUntilIForgetISmelledPheromone--;
            }
            else if(getOneIntersectingObject(Pheromone.class) != null) {
                stepsUntilIForgetISmelledPheromone = 30;
            }
            else {
                randomWalk();
            }
            checkForFood();
        }
    }
    
    private void checkForFood() {
        Food current = (Food)getOneIntersectingObject(Food.class);
        if(current != null) {
           //Greenfoot.stop();
           setImage("ant-with-food.gif");
           carryingFood = true;
           current.takeSome();
        }
        
        //Same as above - no local variable
        //if(getOneIntersectingObject(Food.class) != null) {
            //Greenfoot.stop();
        //}
    }
    
     private void checkForAntHill() {
        AntHill current = (AntHill)getOneIntersectingObject(AntHill.class);
        
        if(current != null) {
           setImage("ant.gif");
           carryingFood = false;
           current.countFood();
        }
    }


}